<?php
/*
TopJax - TOP in a browser via Ajax
http://emergent.urbanpug.com/topjax

Copyright (C) 2005  Matt Miller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

------------------------

This code calls the 'ps'

*/
exec('TERM=xterm ./ps.sh', $top, $error );
exec('TERM=xterm ./up.sh', $uptime, $error );

$g_idle = $_POST["idle"];
$g_sort = $_POST["sort"];

$pid = 0;
$user = 1;
$time = 2;
$cpu_percent = 3;
$memory_percent = 4;
$size = 5;
$tt = 6;
$command = 7;
$show_idle = false;


if ($g_idle == 1) {
	$show_idle = true;
}

$sort_key = $g_sort;

echo "<div id=\"uptime\">";
echo $uptime[0];
echo "</div>";









$first = true;
while (list($key, $val) = each($top)) {
	$val = trim($val);
	$ar = preg_split("/[\s,]+/", $val);
	$k = 0;
	if ($first) {
		$output_line = "<tr id=\"header\">";
	} else {
		$output_line = "<tr class=\"%class%\">";			
	}
	$full_command = "";
	$key = "";
	$cpupct = "";
	$cmd = "";
	while ($k < count($ar)) {
		$v = $ar[$k];
		if ($k == $cpu_percent) {
			$cpupct = $v;
		} else if ($k == $command) {
			$cmd = $v;
		}
		if ($k < 8) {
			if ($first) {
				$v_id = str_replace("%", "", $v); 
				$output_line =  "$output_line<td class=\"mov\" id=\"$v_id\" onclick=\"sortBy($k);\">$v</td>";
			} else {
				$output_line =  "$output_line<td>$v</td>";
			}
		} else {
			$full_command = "$full_command $v";	
		}
		if ($k == $sort_key) {
			$key = $v;
		}
		$k++;
	}
	$output_line =  "$output_line<td>$full_command</td></tr>\n";
	if ($first) {
		echo "<table>";
		echo "$output_line";
	} else {
		if (($show_idle == true) || ($cpupct != "0" && $cpupct != "0.0" && $cpupct != "0.00")) {
			if ($cmd != "ps.sh" && $full_command != "ps -eo pid,user,time,%cpu,%mem,sz,tty,ucomm,command") {
				$oldval = $rows[$key];
				$rows[$key] = $output_line . $oldval;
			}
		}
	}
	$first = false;
}
if (count($rows) > 0) {
	krsort($rows);
	reset($rows);
	while (list($key,$val) = each($rows)) {
		echo $val;
	}
}
echo "</table>\n";
if ($error){
   exec('TERM=xterm ./ps.sh 2>&1', $error );
   echo "Error: ";
   exit($error[0]);
}
?>
