<?
/*
TopJax - TOP in a browser via Ajax
http://emergent.urbanpug.com/topjax

Copyright (C) 2005  Matt Miller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/



	$default_refresh = "2500";
	$version = 0.2;
?>
<html>
<head>
	<title>TopJax</title>
	<link rel="stylesheet" href="topjax.css" type="text/css" media="screen" />
	<script type="text/javascript" src="tw-sack.js"></script>
	<script type="text/javascript">
	var paused = "true";
	var mysort = "3";
	var myidle = "0";
	function loopIt() {	
		var btn = document.getElementById("pauseButton");
		if (paused == "false") {
			paused = "true";
			clearInterval(tid);
			btn.value="Start";
		} else {
			paused = "false";
			tid=setInterval('getData()', <? echo $default_refresh ?>);
			btn.value="Pause";
		}
	}
	function toggleIdle() {
		var btn = document.getElementById("idleButton");
		if (myidle == "1") {
			myidle = "0";
			btn.value="Show Idle";
		} else {
			myidle = "1";	
			btn.value="Don't Show Idle";
		}
	}
	function getData() {
		var mydata = 'sort=' + mysort + '&idle=' + myidle;
		ajax = new sack('top.php');
		ajax.element = 'topdiv';
		ajax.runAJAX(mydata);
	}
	function sortBy(i) {
		var btn = document.getElementById("sortby");
		mysort = i;
		if (i == 0) {
			btn.innerHTML = "Sorted By: <em>Process ID</em>";
		} else if (i == 1) {
			btn.innerHTML = "Sorted By: <em>User ID</em>";
		} else if (i == 2) {
			btn.innerHTML = "Sorted By: <em>CPU Time</em>";
		} else if (i == 3) {
			btn.innerHTML = "Sorted By: <em>%CPU Usage</em>";
		} else if (i == 4) {
			btn.innerHTML = "Sorted By: <em>%Memory Usage</em>";
		} else if (i == 5) {
			btn.innerHTML = "Sorted By: <em>Memory Size</em>";
		} else if (i == 6) {
			btn.innerHTML = "Sorted By: <em>Terminal</em>";
		} else if (i == 7) {
			btn.innerHTML = "Sorted By: <em>Command</em>";
		} else {
			btn.innerHTML = "Sorted By: <em>CPU Usage?</em>";
		}
	}
	</script>
</head>
<body onLoad="getData();loopIt();">
<input id="pauseButton" type="button" value="Pause" onclick="loopIt();return false;" />
<input id="idleButton" type="button" value="Show Idle" onclick="toggleIdle();return false;" />
<span id="sortby">Sorted By: <em>%CPU Usage</em></span>
<span id="clickon">Click on column headers to sort.  </span>
<a id="help" href="http://emergent.urbanpug.com/topjax/help.php">Help!</a>
<div id="topdiv">
Loading ...
</div>
<a href="http://emergent.urbanpug.com/topjax">TopJax</a> Version <? echo $version; ?> &copy; 2005 Matt Miller | Released under the <a href="http://www.gnu.org/copyleft/gpl.html">GPL</a> 
</body>
</html>
